<?php
namespace Avalon\Costompaymentgr\Controller\Index;

class Tbigetid extends \Magento\Framework\App\Action\Action
{
	protected $_pageFactory;
	protected $_resultJsonFactory;
	protected $_checkoutSession;
	protected $_orderFactory;
	protected $_order_id;
	protected $_resource;
	protected $_connection;

	public function __construct(
		\Magento\Framework\App\Action\Context $context,
		\Magento\Framework\View\Result\PageFactory $pageFactory,
		\Magento\Framework\Controller\Result\JsonFactory $resultJsonFactory,
        \Magento\Checkout\Model\Session $checkoutSession,
        \Magento\Sales\Model\OrderFactory $orderFactory,
		\Magento\Framework\App\ResourceConnection $resource
	)
	{
		$this->_pageFactory = $pageFactory;
		$this->_resultJsonFactory = $resultJsonFactory;
		$this->_checkoutSession = $checkoutSession;
		$this->_orderFactory = $orderFactory;
		$this->_order_id = $this->getRealOrderId();
		$this->_resource = $resource;
		$this->_connection = $resource->getConnection();
		return parent::__construct($context);
	}

    public function getRealOrderId()
    {
        $order = $this->_checkoutSession->getLastRealOrder();
		$orderId = $order->getEntityId();
        return $order->getIncrementId();
    }

    public function getOrder()
    {
        $order = $this->_orderFactory->create()->loadByIncrementId($this->_order_id);
        return $order;
    }

	public function execute()
	{
		if ((isset($_GET['tag'])) && ($_GET['tag'] == 'jLhrHYsfPQ3Gu9JgJPLJ')){
			if ($this->_objectManager->create('Avalon\Costompaymentgr\Helper\Data')->getConfig('avalon_custompaymentmethodgr_tab_options/properties_tbigr/grtbi_unicid')){
				$tbigr_unicid = $this->_objectManager->create('Avalon\Costompaymentgr\Helper\Data')->getConfig('avalon_custompaymentmethodgr_tab_options/properties_tbigr/grtbi_unicid');
			}else{
				$tbigr_unicid = "";
			}	
			if ($this->_objectManager->create('Avalon\Costompaymentgr\Helper\Data')->getConfig('avalon_custompaymentmethodgr_tab_options/properties_tbigr/grtbi_store_id')){
				$tbigr_store_id = $this->_objectManager->create('Avalon\Costompaymentgr\Helper\Data')->getConfig('avalon_custompaymentmethodgr_tab_options/properties_tbigr/grtbi_store_id');
			}else{
				$tbigr_store_id = "";
			}	
			if ($this->_objectManager->create('Avalon\Costompaymentgr\Helper\Data')->getConfig('avalon_custompaymentmethodgr_tab_options/properties_tbigr/grtbi_username')){
				$tbigr_username = $this->_objectManager->create('Avalon\Costompaymentgr\Helper\Data')->getConfig('avalon_custompaymentmethodgr_tab_options/properties_tbigr/grtbi_username');
			}else{
				$tbigr_username = "";
			}	
			if ($this->_objectManager->create('Avalon\Costompaymentgr\Helper\Data')->getConfig('avalon_custompaymentmethodgr_tab_options/properties_tbigr/grtbi_password')){
				$tbigr_password = $this->_objectManager->create('Avalon\Costompaymentgr\Helper\Data')->getConfig('avalon_custompaymentmethodgr_tab_options/properties_tbigr/grtbi_password');
			}else{
				$tbigr_password = "";
			}	

			$tbigr_mod_version = '';
			$tbigr_mod_version = $this->_objectManager->get('Magento\Framework\Module\ModuleList')->getOne('Avalon_Costompaymentgr')['setup_version'];
			
			$tbigr_ch = curl_init();
			curl_setopt($tbigr_ch, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($tbigr_ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($tbigr_ch, CURLOPT_URL, $this->_objectManager->create('Avalon\Costompaymentgr\Helper\Data')->getTbigrLiveUrl() . '/function/getparameters.php?cid='.$tbigr_unicid);
			$paramstbigr = json_decode(curl_exec($tbigr_ch), true);
			curl_close($tbigr_ch);
	
			$tbigr_minprice_tbi = $paramstbigr['tbi_minstojnost'];
			$tbigr_theme = $paramstbigr['tbi_theme'];
			$tbigr_btn_theme = $paramstbigr['tbi_btn_theme'];
			$tbigr_custom_button_status = $paramstbigr['tbi_custom_button_status'];
			$tbigr_url = $this->_objectManager->create('Avalon\Costompaymentgr\Helper\Data')->getTbigrLiveUrl() . "/function/status.php";
			if (!is_null($this->getOrder()->getBillingAddress())){
				$billingstreet = $this->getOrder()->getBillingAddress()->getStreet();
			}
			if (!is_null($this->getOrder()->getShippingAddress())){
				$shippingstreet = $this->getOrder()->getShippingAddress()->getStreet();
			}
			
			$tbigr_price = $this->getOrder()->getGrandTotal();
			if ($this->getOrder()->getCustomerId() === NULL){
				$tbigr_fname = is_null($this->getOrder()->getBillingAddress()) ? '' : $this->getOrder()->getBillingAddress()->getFirstname();
				$tbigr_lname = is_null($this->getOrder()->getBillingAddress()) ? '' : $this->getOrder()->getBillingAddress()->getLastname();		
			}else{
				$tbigr_fname = $this->getOrder()->getCustomerFirstname();
				$tbigr_lname = $this->getOrder()->getCustomerLastname();
			}
			$tbigr_cnp = '';
			$tbigr_email = $this->getOrder()->getCustomerEmail();
			$tbigr_billing_phone = is_null($this->getOrder()->getBillingAddress()) ? '' : $this->getOrder()->getBillingAddress()->getTelephone();
			$tbigr_billing_address = isset($billingstreet[0]) ? $billingstreet[0] : '';
			$tbigr_billing_city = is_null($this->getOrder()->getBillingAddress()) ? '' : $this->getOrder()->getBillingAddress()->getCity();
			$tbigr_billing_country = is_null($this->getOrder()->getBillingAddress()) ? '' : $this->getOrder()->getBillingAddress()->getRegion();
			$tbigr_shipping_address = isset($shippingstreet[0]) ? $shippingstreet[0] : '';
			$tbigr_shipping_city = is_null($this->getOrder()->getShippingAddress()) ? '' : $this->getOrder()->getShippingAddress()->getCity();
			$tbigr_shipping_country = is_null($this->getOrder()->getShippingAddress()) ? '' : $this->getOrder()->getShippingAddress()->getRegion();
			$tbigr_person_type = '';
			$tbigr_net_income = '';
			$tbigr_instalments = '';

			$ident = 0;
			$tbigr_items = array();
			$tbigr_api_items = array();
			$tbigr_items[0]['name'] = '';
			$tbigr_api_items[0]['name'] = '';
			$tbigr_items[0]['qty'] = '';
			$tbigr_api_items[0]['qty'] = '';
			$tbigr_items[0]['price'] = '';
			$tbigr_api_items[0]['price'] = '';
			$tbigr_items[0]['category'] = '';
			$tbigr_api_items[0]['category'] = '';
			$tbigr_items[0]['sku'] = '';
			$tbigr_api_items[0]['sku'] = '';
			$tbigr_items[0]['ImageLink'] = '';
			$tbigr_api_items[0]['ImageLink'] = '';
			foreach($this->getOrder()->getAllVisibleItems() as $cart_item){
				$_product = $cart_item->getProduct();
				$_product_id = $cart_item->getProductId();
				$tbigr_items[$ident]['name'] = $_product['name'];
				$tbigr_api_items[$ident]['name'] = $_product['name'];
				$tbigr_quantity = intval($cart_item->getQtyOrdered());
				$tbigr_items[$ident]['qty'] = "$tbigr_quantity";
				$tbigr_api_items[$ident]['qty'] = "$tbigr_quantity";
				$tbigr_price_items = $cart_item->getPrice();
				$tbigr_items[$ident]['price'] = "$tbigr_price_items";
				$tbigr_api_items[$ident]['price'] = "$tbigr_price_items";
				$cats = $_product->getCategoryIds();
				foreach ($cats as $cat_id){
					$tbigr_category = $cat_id;
				}
				$tbigr_items[$ident]['category'] = "$tbigr_category";
				$tbigr_api_items[$ident]['category'] = "$tbigr_category";
				$tbigr_product_id = $cart_item->getSku();
				$tbigr_items[$ident]['sku'] = "$tbigr_product_id";
				$tbigr_api_items[$ident]['sku'] = "$tbigr_product_id";
				$helperImport = $this->_objectManager->get('\Magento\Catalog\Helper\Image');
				$tbigr_image = $helperImport->init($_product, 'product_page_image_large')->setImageFile($_product->getFile())->getUrl();
				$tbigr_imagePath = isset($tbigr_image) ? $tbigr_image : '';
				$tbigr_items[$ident]['ImageLink'] = "$tbigr_imagePath";
				$tbigr_api_items[$ident]['ImageLink'] = "$tbigr_imagePath";
				$ident++;
			}

			// Create tbigr order i data base
			$tbigr_add_ch = curl_init();
			curl_setopt($tbigr_add_ch, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($tbigr_add_ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($tbigr_add_ch, CURLOPT_URL, $this->_objectManager->create('Avalon\Costompaymentgr\Helper\Data')->getTbigrLiveUrl() . '/function/addorders.php?cid='.$tbigr_unicid);
			curl_setopt($tbigr_add_ch, CURLOPT_POST, 1);
			
			$tbigr_post = array(
				'store_id'      => $tbigr_store_id,
				'order_id'      =>  $this->getRealOrderId(),
				'type'      	=>  'TBI',
				'back_ref'      =>  $tbigr_url,
				'order_total'   =>  $tbigr_price,
				'username'	=> $tbigr_username,
				'password'	=> $tbigr_password,
				'customer'      =>  array(
					'fname'         => $tbigr_fname,
					'lname'         => $tbigr_lname,
					'cnp'           => $tbigr_cnp, //$tbigr_cnp,
					'email'         => $tbigr_email,
					'phone'         => $tbigr_billing_phone,
					'billing_address'      => $tbigr_billing_address,
					'billing_city'          => $tbigr_billing_city,
					'billing_county'        => $tbigr_billing_country,
					'shipping_address'      => $tbigr_shipping_address,
					'shipping_city'          => $tbigr_shipping_city,
					'shipping_county'        => $tbigr_shipping_country,
					'person_type'   => $tbigr_person_type,
					'net_income'    => $tbigr_net_income,
					'instalments'	=> $tbigr_instalments
				),
				'items' => $tbigr_items
			);
	
			curl_setopt($tbigr_add_ch, CURLOPT_POSTFIELDS, http_build_query($tbigr_post));
			$paramstbigradd=json_decode(curl_exec($tbigr_add_ch), true);
			curl_close($tbigr_add_ch);				
			// Create tbigr order i data base
	
			if (isset($paramstbigradd['status']) && ($paramstbigradd['status'] == 'Yes')){
				// save to tbiorders file
				$dataUpdate = ["tbigr_status" => "Draft"];
				$whereUpdate = ['increment_id = ?' => (int)$this->getRealOrderId()];
				$tableSalesOrderGrid = $this->_connection->getTableName("sales_order_grid");
				$this->_connection->update($tableSalesOrderGrid, $dataUpdate, $whereUpdate);
				
				// send to softinteligens
				$tbigr_post = array(
					'firstname'      	=> $tbigr_fname,
					'lastname'      	=> $tbigr_lname,
					'surname'      		=> '',
					'pin'   			=> $tbigr_cnp,
					'origin'			=> 'POS_Online',
					'resellercode'		=> $tbigr_store_id,
					'email'         	=> $tbigr_email,
					'phone'         	=> $tbigr_billing_phone,
					'billingaddress'	=> array(
						'country'			=> '',
						'county'        	=> $tbigr_billing_country,
						'city'         	 	=> $tbigr_billing_city,
						'streetname'      	=> $tbigr_billing_address,
						'streetno'			=> '',
						'buildingno'		=> '',
						'entranceno'		=> '',
						'floorno'			=> '',
						'apartmentno'		=> '',
						'postalcode'		=> ''
					),
					'deliveryaddress'	=> array(
						'country'			=> '',
						'county'        	=> $tbigr_shipping_country,
						'city'         	 	=> $tbigr_shipping_city,
						'streetname'      	=> $tbigr_shipping_address,
						'streetno'			=> '',
						'buildingno'		=> '',
						'entranceno'		=> '',
						'floorno'			=> '',
						'apartmentno'		=> '',
						'postalcode'		=> ''
					),
					'orderid'   		=> $paramstbigradd['newid'],
					'bankingproductcode'=> '',
					'promo'				=> '0',
					'installments'		=> $tbigr_instalments,
					'ordertotal'		=> $tbigr_price,
					'installmentamount'	=> '',
					'items' 			=> $tbigr_api_items,
					'siteurl'			=> $this->_objectManager->create('Avalon\Costompaymentgr\Helper\Data')->getTbigrLiveUrl(),
					'statusurl'			=> $tbigr_url
				);
				
				if ($paramstbigr['tbi_testenv'] == 1){
					$tbigr_envurl = $paramstbigr['tbi_testurl'];
					$tbigr_env = 'tbi_test';
				}else{
					$tbigr_envurl = $paramstbigr['tbi_liveurl'];
					$tbigr_env = 'tbi_live';
				}

				$tbi_pause_txt = $paramstbigr['tbi_pause_txt'];
				
				$_SESSION['send_tbigr'] = 'No';

				$status = 1;
				$retenc = urlencode(base64_encode(json_encode($tbigr_post, JSON_UNESCAPED_UNICODE)));
			}else{
				$status = 0;
				$retenc = __("error add order id!");
				$tbigr_envurl = "";
				$tbi_pause_txt = "";
			}
		}else{
			$status = 0;
			$retenc = "error";
			$tbigr_envurl = "";
			$tbi_pause_txt = "";
		}
		
		$result = $this->_resultJsonFactory->create();
		$result->setData(['msg_status' => $status, 'retid' => $retenc, 'tbigr_envurl' => $tbigr_envurl, 'tbi_pause_txt' => $tbi_pause_txt, 'tbigr_env' => $tbigr_env]);
		return $result;
	}
}